/*
 * @(#)AListOfCities.java  20 March 2003
 */

/**
 * Abstract list containing Objects class
 */
public abstract class AList {

	// Is this list empty?
	public abstract boolean isEmpty ();

	// Assuming this list is not empty, what is its first element?
	public abstract Object first ();

	// Assuming this list is not empty, what are its remaining elements?
	public abstract AList rest ();
	
	// Return a reverse of this list
	 public abstract AList reverse();

	// Append a list to this list
	public abstract AList append(AList list);

	// Returns an IRange that generates the elements of this list in order.
	 public IRange iterator () {
		 return new ListRange (this);
	 }
 
	// Is this list equal to that one?
	 public boolean equals (Object that) {
		IRange ir1 = this.iterator();
		IRange ir2 = ((AList) that).iterator();
		boolean equalSoFar = true;
		
		for ( ; equalSoFar && ir1.hasMore() && ir2.hasMore(); ) {
			 if (ir1.current() != ir2.current())
			 equalSoFar = false;
			 ir1.next();
			 ir2.next();
		 }
	
		 // The loop terminated because at least one of these is true:
		 // -- equalSoFar is false (we found unequal elements)
		 // -- ir1 has no more elements to generate
		 // -- ir2 has no more elements to generaet
	
		 if (ir1.hasMore() != ir2.hasMore())
			 return false;
		 else return equalSoFar;
	 }


 }
