/*
 * @(#)ConsListOfCities.java  20 February 2003
 */

/**
 * Nonempty list of cities class
 */
public class ConsList extends AList {

/*---------------------------------------------------------------
 Member data
 --------------------------------------------------------------*/
    Object first;
    AList rest;
    
/*---------------------------------------------------------------
 Constructor
 --------------------------------------------------------------*/
    ConsList (Object s, AList r) {
        this.first = s;
        this.rest  = r;
    }

	public boolean isEmpty () { return false; }

	public Object first () { return this.first; }
	public AList rest () { return this.rest; }
	
/*---------------------------------------------------------------
 Reverse all member data values.
 --------------------------------------------------------------*/
	public AList reverse() {
		IRange ir = new ListRange(this);
		AList reverseList = new MTList();
		for (; ir.hasMore(); ir.next()) {
			reverseList = new ConsList(ir.current(), reverseList);
		}
		return reverseList;
	}

	/*---------------------------------------------------------------
	 Appends the a list to this list. 
	 --------------------------------------------------------------*/
	public AList append(AList list) {
		
		if (!(list.isEmpty())) {
			
			// reverse the first list
			AList rev = this.reverse();
			
			// remove next item from reveresed list
			// and 'prepend' to the second list
			while (!(rev.isEmpty())){		
				list = new ConsList(rev.first(), list);
				rev = rev.rest();
			}
			
			// save the new list as this
			this.first = list.first();
			this.rest  = list.rest();
		}
		
		return this;
	}

/*---------------------------------------------------------------
 Print all member data values.
 --------------------------------------------------------------*/
	public String toString(){
		return("\nnew " + getClass().getName() + "(" + 
					first             + ", " + 
					rest   + ")");
	}
    
}
    
