import java.util.Vector;
/* ------------------------------------------------------------------
   Functional (External) Iterator Pattern:
   iterator for a vector of cities 
*/

class VectorRange implements IRange {

    /*-------------------------------------------------------- 
      Member data
      *------------------------------------------------------*/
    Vector v; /* reference to this list */
    int curr;
    int size;
    
    /*-------------------------------------------------------- 
      Constructor
      *------------------------------------------------------*/
	VectorRange(Vector v) { 
		this.v = v; 
		this.curr = 0;
		this.size = v.size();
	}
        
    /*--------------------------------------------------------
      Methods to implement the IRange interface
      *------------------------------------------------------*/

    public void next() {
        if (this.hasMore())
        	curr = curr + 1; 
    }


    public Object current() {
        return v.elementAt(curr); 
    }
    
    public boolean hasMore() {
        return (curr < size); 
    }
}
